<?php
	
if( !defined( 'ABSPATH' ) )
	exit;
	
	
class FA_SportOdds_Odds_Widget extends WP_Widget {

	public function __construct() {
		$widget_ops = array('classname' => 'widget_text', 'description' => __('FA SportOdds Widget'));
		$control_ops = array('width' => 400, 'height' => 350);
		parent::__construct('fa_sportodds_odds', __('FA Sport Odds'), $widget_ops, $control_ops);
	}

	public function widget( $args, $instance ) {

		$title = apply_filters( 'widget_title', empty( $instance['title'] ) ? '' : $instance['title'], $instance, $this->id_base );
		$bet_now = (!empty($instance['bet_now'])) ? $instance['bet_now'] : 'BET NOW! &gt;';
		$profit_text = (!empty($instance['profit_text'])) ? $instance['profit_text'] : 'Profit';
		$stake_text = (!empty($instance['stake_text'])) ? $instance['stake_text'] : 'Stake';

		$pri_bid = (!empty($instance['pri_bid'])) ? (int) $instance['pri_bid'] : 0;
		$sec_bid = (!empty($instance['sec_bid'])) ? (int) $instance['sec_bid'] : 0;
		$lines = (!empty($instance['lines'])) ? (int) $instance['lines'] : 3;
		$stake = (!empty($instance['stake'])) ? (int) $instance['stake'] : 20;
		$odds = (!empty($instance['odds'])) ? (int) $instance['odds'] : 'dec';
		
		if ($pri_bid > 0)
			$pri_lid = (!empty($instance['pri_lid'])) ? (int) $instance['pri_lid'] : 0;
		if ($sec_bid > 0)
			$sec_lid = (!empty($instance['sec_lid'])) ? (int) $instance['sec_lid'] : 0;

		if ($pri_bid == 0 && $sec_bid == 0 && ($pri_lid == 0 || $sec_lid == 0)) // nothing to display
			return;

		// get feeds
		$pri_feed = $sec_feed = false;
		$obj = FA_SportOdds::get_instance();
		if ($pri_bid > 0 && $pri_lid > 0){
			$pri_feed = $obj->get_feed($pri_bid, $pri_lid);
			$pri_matches = $this->parse_feed($obj->get_feed($pri_bid, $pri_lid, $odds));
		}
		if ($sec_bid > 0 && $sec_lid > 0){
			$sec_feed = $obj->get_feed($sec_bid, $sec_lid);
			$sec_matches = $this->parse_feed($obj->get_feed($sec_bid, $sec_lid, $odds));
		}
		
		
		if($lines > 1){
			if($sec_bid > 0 && $sec_lid > 0){
				for ($i = 1; $i < $lines-1 ; $i++) {
					$check = $lines - $i;
					$val = 100/$lines;
					$per = $val*($check);
					if($per >= 50 && $per <= 75){
						if($instance['order'] == 'random'){
							shuffle($pri_matches);
							$pri_lines = array_slice($pri_matches, 0, $check);
							shuffle($sec_matches);
							$sec_lines = array_slice($sec_matches, 0, $lines-$check);
						}
						else {
							$pri_lines = array_slice($pri_matches, 0, $check);
							$sec_lines = array_slice($sec_matches, 0, $lines-$check);
						}
						
						break;
					}
				}

				$merge_array = array_merge($pri_lines, $sec_lines);
			}
			else {
					if($instance['order'] == 'random'){
						shuffle($pri_matches);
						$pri_lines = array_slice($pri_matches, 0, $lines);
					}
					else {
						$pri_lines = array_slice($pri_matches, 0, $lines);
					}

					$merge_array = $pri_lines;
			}
		
		}
		else {

			if($instance['order'] == 'random'){
				shuffle($pri_matches);
				$pri_lines = array_slice($pri_matches, 0, $lines);
			}
			else {
				$pri_lines = array_slice($pri_matches, 0, $lines);
			}

			$merge_array = $pri_lines;
		}			

		//$lines = array_slice($pri_matches, 0, $lines);
		echo $args['before_widget'];
		if ( ! empty( $title ) ) {
			echo $args['before_title'] . $title . $args['after_title'];
		} ?>

		<?php 
		if($instance['order'] == 'time'): 
			foreach ($merge_array as $key => $value) {
				$time[$key] = $value['kickoff_GMT'];

			} 
			array_multisort($time, SORT_ASC, $merge_array);
		endif;

		$obj = FA_SportOdds::get_instance();
		
		if ($obj->options['status'] == 'approved') {
			$link_desktop = $obj->options['link_desktop'] . '#';
			$link_mobile = $obj->options['link_mobile'] . '#home#';
		}
		else {
			$link_desktop = 'https://www.betfinal.com/#';
			$link_mobile = 'https://m.betfinal.com/#home#';
		}

		?>
			<script>
			FA_SportOddsLinks = { desktop: '<?php echo $link_desktop; ?>', mobile: '<?php echo $link_mobile; ?>' };
			</script>
			<div class="fa-sportodds-widget <?php echo $instance['theme']; ?>">
			<?php foreach($merge_array as $match): FA_SportOdds::translate($match); $font_class = (strlen($match['home_team'].$match['away_team']) > 30) ? 'small-font' : ''; ?>
				<p class="event <?php echo $font_class; ?>"><i class="icon b_<?php echo $match['BranchID']; ?>"></i> <?php echo $match['home_team']; ?> - <?php echo $match['away_team']; ?></p>
				<?php if($instance['show_time']): ?><span data-gmt="<?php echo $match['kickoff_GMT']; ?>" class="league-time"> <?php echo $match['kickoff_GMT']; ?></span><?php endif; ?><?php if($instance['show_league']): ?><span class="league-name"><?php echo $match['LeagueName']; ?> </span><?php endif; ?>
				<div class="odds" data-meid="<?php echo $match['MEID']; ?>" data-id="<?php echo $match['ID']; ?>"><div class="home<?php if ($match['odds']['draw']['odds']=='0.00'):?> right-border<?php endif; ?>" data-line="<?php echo substr($match['odds']['home']['line'],1); ?>" data-groupline="<?php echo $match['GroupID']; ?>"><span>1</span><?php echo $match['odds']['home']['odds']; ?></div><?php if ($match['odds']['draw']['odds']!='0.00'):?><div class="draw" data-line="<?php echo substr($match['odds']['draw']['line'], 1); ?>" data-groupline="<?php echo $match['GroupID']; ?>"><span>X</span><?php echo $match['odds']['draw']['odds']; ?></div><?php endif; ?><div class="away" data-line="<?php echo substr($match['odds']['away']['line'],1); ?>" data-groupline="<?php echo $match['GroupID']; ?>"><span>2</span><?php echo $match['odds']['away']['odds']; ?></div></div>
			<?php endforeach; ?>
				<div class="fa-sportodds-widget-bottom">
					<a id="fa-sportodds-betnow" class="button" href="https://www.betfinal.com" onclick="return FA_SportOdds.betNow()"><?php echo $bet_now; ?></a>
					<p><?php echo $stake_text; ?>: <input type="number" value="<?php echo $stake; ?>" id="fa-sportodds-stake" max="999" maxlength="3" size="4" min="1" onchange="FA_SportOdds.calcProfit()"></p>
					<p><?php echo $profit_text; ?>: <span id="fa-sportodds-profit"></span></p>
				</div>
				<?php if($instance['branding']): ?>
				<div class="fa-sportodds-widget-logo">
					<a href="<?php echo $link_desktop; ?>" title="Betfinal">
					<?php if($instance['theme'] == 'dark'): ?>
					<img class="widget-logo" src="https://b79b15ebd180fcf99da4-58eef1a95b7c3b1530ae0f3b29d43b23.ssl.cf5.rackcdn.com/black_logo.png" alt="Betfinal Promo">
					<?php endif; ?>
					<?php if($instance['theme'] == 'light'): ?>
					<img class="widget-logo" src="https://b79b15ebd180fcf99da4-58eef1a95b7c3b1530ae0f3b29d43b23.ssl.cf5.rackcdn.com/betfinal.png" alt="Betfinal Promo">
					<?php endif; ?>
					</a>
				</div>
				<?php endif; ?>

			</div>
		<?php
		echo $args['after_widget'];
	}

	public function update( $new_instance, $old_instance ) {
		$instance = $old_instance;
		$instance['title'] = sanitize_text_field( $new_instance['title'] );
		$instance['bet_now'] = sanitize_text_field( $new_instance['bet_now'] );
		$instance['profit_text'] = sanitize_text_field( $new_instance['profit_text'] );
		$instance['stake_text'] = sanitize_text_field( $new_instance['stake_text'] );

		$instance['animation'] = ! empty( $new_instance['animation'] );
		$instance['branding'] = ! empty( $new_instance['branding'] );
		$instance['show_league'] = ! empty( $new_instance['show_league'] );
		$instance['show_time'] = ! empty( $new_instance['show_time'] );
		
		$instance['lines'] = (int) $new_instance['lines'];
		$instance['stake'] = (int) $new_instance['stake'];
		$instance['pri_bid'] = (int) $new_instance['sport_primary'];
		$instance['pri_lid'] = (int) $new_instance['league_primary'];
		$instance['sec_bid'] = (int) $new_instance['sport_secondary'];
		$instance['sec_lid'] = (int) $new_instance['league_secondary'];
		
		$instance['order'] = $new_instance['order'];
		$instance['odds'] = $new_instance['odds'];
		$instance['theme'] = $new_instance['theme'];

		return $instance;
	}

	public function form( $instance ) {
		
		$sportodds_obj = FA_SportOdds::get_instance();
		
		$instance = wp_parse_args( (array) $instance, array( 'title' => 'Odds highlights', 'bet_now' => 'Bet Now >', 'odds' => 'dec', 'order' => 'random', 'theme' => 'dark', 'lines' => 3, 'branding' => 1, 'animation' => 1, 'show_league' => 0, 'show_time' => 0,
		  'stake' => 20, 'profit_text' => 'Profit', 'stake_text' => 'Stake' ) );

		$title = sanitize_text_field( $instance['title'] );
		$bet_now = sanitize_text_field( $instance['bet_now'] );
		$profit_text = sanitize_text_field( $instance['profit_text'] );
		$stake_text = sanitize_text_field( $instance['stake_text'] );

		$animation = (int) $instance['animation'];
		$branding = (int) $instance['branding'];
		$lines = (int) $instance['lines'];
		$stake = (int) $instance['stake'];
		$pri_bid = (int) $instance['pri_bid'];
		$pri_lid = (int) $instance['pri_lid'];
		$sec_bid = (int) $instance['sec_bid'];
		$sec_lid = (int) $instance['sec_lid'];
		$show_league = (int) $instance['show_league'];
		$show_time = (int) $instance['show_time'];
		
		$order = $instance['order'];
		$odds = $instance['odds'];
		$theme = $instance['theme'];

		?>
		<p><label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Title:'); ?></label>
		<input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo esc_attr($title); ?>" /></p>
		<script>var FA_SportOdds_LeagueDropdown = '#<?php echo $this->get_field_id('league_primary'); ?>';</script>
		
		<?php // PRIMARY ?>
		<p><label for="<?php echo $this->get_field_id('sport_primary'); ?>"><?php _e('Primary Selection:'); ?></label>
		<select class="widefat" id="<?php echo $this->get_field_id('sport_primary'); ?>" name="<?php echo $this->get_field_name('sport_primary'); ?>" onchange="FA_SportOdds_GetLeagues(this.value, '#<?php echo $this->get_field_id('league_primary'); ?>')">	
			<option value="0">-- Select sport --</option>
			<?php foreach ($sportodds_obj->get_available_sports() as $sportId => $sportName): ?>
				<option value="<?php echo $sportId; ?>" <?php selected($sportId, $pri_bid); ?>><?php echo esc_attr($sportName); ?></option>
			<?php endforeach; ?>
		</select>
		<select class="widefat" id="<?php echo $this->get_field_id('league_primary'); ?>" name="<?php echo $this->get_field_name('league_primary'); ?>">
			<option value="0">-- Select league --</option>
		</select></p>
		
		<?php // SECONDARY ?>
		<p><label for="<?php echo $this->get_field_id('sport_secondary'); ?>"><?php _e('Secondary Selection:'); ?></label>
		<select class="widefat" id="<?php echo $this->get_field_id('sport_secondary'); ?>" name="<?php echo $this->get_field_name('sport_secondary'); ?>" onchange="FA_SportOdds_GetLeagues(this.value, '#<?php echo $this->get_field_id('league_secondary'); ?>')">
			<option value="0">-- Select sport --</option>
			<?php foreach ($sportodds_obj->get_available_sports() as $sportId => $sportName): ?>
				<option value="<?php echo $sportId; ?>" <?php selected($sportId, $sec_bid); ?>><?php echo esc_attr($sportName); ?></option>
			<?php endforeach; ?>
		</select>
		<select class="widefat" id="<?php echo $this->get_field_id('league_secondary'); ?>" name="<?php echo $this->get_field_name('league_secondary'); ?>">
			<option value="0">-- Select league --</option>
		</select></p>

		<p><label for="<?php echo $this->get_field_id('lines'); ?>"><?php _e('Number of matches to display:'); ?></label>
		<input class="" id="<?php echo $this->get_field_id('lines'); ?>" name="<?php echo $this->get_field_name('lines'); ?>" type="number" value="<?php echo esc_attr($lines); ?>" size="3" max="10" min="1" maxlength="2"/></p>

		<p><label for="<?php echo $this->get_field_id('stake'); ?>"><?php _e('Default Stake:'); ?></label>
		<input class="" id="<?php echo $this->get_field_id('stake'); ?>" name="<?php echo $this->get_field_name('stake'); ?>" type="number" value="<?php echo esc_attr($stake); ?>" size="3" max="1000" min="1" maxlength="4"/></p>
		
		<!--<p><input id="<?php echo $this->get_field_id('animation'); ?>" name="<?php echo $this->get_field_name('animation'); ?>" type="checkbox"<?php checked( $animation ); ?> />&nbsp;<label for="<?php echo $this->get_field_id('animation'); ?>"><?php _e('Add animations'); ?></label></p>-->

		<p><input id="<?php echo $this->get_field_id('branding'); ?>" name="<?php echo $this->get_field_name('branding'); ?>" type="checkbox"<?php checked( $branding ); ?> />&nbsp;<label for="<?php echo $this->get_field_id('branding'); ?>"><?php _e('Add Betfinal logo (will improve conversion)'); ?></label></p>
		
		<p><input id="<?php echo $this->get_field_id('show_league'); ?>" name="<?php echo $this->get_field_name('show_league'); ?>" type="checkbox"<?php checked( $show_league ); ?> />&nbsp;<label for="<?php echo $this->get_field_id('show_league'); ?>"><?php _e('Show League Name'); ?></label></p>

		<p><input id="<?php echo $this->get_field_id('show_time'); ?>" name="<?php echo $this->get_field_name('show_time'); ?>" type="checkbox"<?php checked( $show_time ); ?> />&nbsp;<label for="<?php echo $this->get_field_id('show_time'); ?>"><?php _e('Show Kickoff Time'); ?></label></p>

		<p><?php _e('Order: '); ?>
		<label for="<?php echo $this->get_field_id('order_rand'); ?>"><input id="<?php echo $this->get_field_id('order_rand'); ?>" name="<?php echo $this->get_field_name('order'); ?>" type="radio"<?php checked( $order, 'random' ); ?> value="random"/> Random</label>&nbsp;
		<label for="<?php echo $this->get_field_id('order_time'); ?>"><input id="<?php echo $this->get_field_id('order_time'); ?>" name="<?php echo $this->get_field_name('order'); ?>" type="radio"<?php checked( $order, 'time' ); ?> value="time" />Date</label>
		</p>

		<!--<p><?php _e('Odds Type: '); ?>
		<label for="<?php echo $this->get_field_id('odds_dec'); ?>"><input id="<?php echo $this->get_field_id('odds_dec'); ?>" name="<?php echo $this->get_field_name('odds'); ?>" type="radio"<?php checked( $odds, 'dec' ); ?> value="dec"/> Decimal</label>&nbsp;
		<label for="<?php echo $this->get_field_id('odds_fra'); ?>"><input id="<?php echo $this->get_field_id('odds_fra'); ?>" name="<?php echo $this->get_field_name('odds'); ?>" type="radio"<?php checked( $odds, 'fra' ); ?> value="fra" />Fractional</label>
		</p>-->
		
		<p><?php _e('Color Theme: '); ?>
		<label for="<?php echo $this->get_field_id('theme_dark'); ?>"><input id="<?php echo $this->get_field_id('theme_dark'); ?>" name="<?php echo $this->get_field_name('theme'); ?>" type="radio"<?php checked( $theme, 'dark' ); ?> value="dark"/> Dark</label>&nbsp;
		<label for="<?php echo $this->get_field_id('theme_light'); ?>"><input id="<?php echo $this->get_field_id('theme_light'); ?>" name="<?php echo $this->get_field_name('theme'); ?>" type="radio"<?php checked( $theme, 'light' ); ?> value="light" />Light</label><br>
		<em><small>(If your theme has a dark background color choose light theme)</small></em>
		</p>

		<p><label for="<?php echo $this->get_field_id('bet_now'); ?>"><?php _e('Bet Now Button Tranlation Text:'); ?></label>
		<input class="widefat" id="<?php echo $this->get_field_id('bet_now'); ?>" name="<?php echo $this->get_field_name('bet_now'); ?>" type="text" value="<?php echo esc_attr($bet_now); ?>" /></p>

		<p><label for="<?php echo $this->get_field_id('profit_text'); ?>"><?php _e('Profit Translation:'); ?></label>
		<input class="widefat" id="<?php echo $this->get_field_id('profit_text'); ?>" name="<?php echo $this->get_field_name('profit_text'); ?>" type="text" value="<?php echo esc_attr($profit_text); ?>" /></p>

		<p><label for="<?php echo $this->get_field_id('stake_text'); ?>"><?php _e('Stake Translation:'); ?></label>
		<input class="widefat" id="<?php echo $this->get_field_id('stake_text'); ?>" name="<?php echo $this->get_field_name('stake_text'); ?>" type="text" value="<?php echo esc_attr($stake_text); ?>" /></p>
		
		<p>To view your earnings or add translations go to:<br>Settings -&gt; <a href="<?php echo admin_url('options-general.php?page=fa-odds-account-page'); ?>">FA Sport Odds MyAccount</a>.</p>
		<p>Need help? Contact our support at <a href="mailto:info@finalaffiliates.com?subject=Sport Odds Widget">info@finalaffiliates.com</a></p>
		<?php 
			if (! empty($pri_bid) && ! empty($pri_lid)): ?>
		<script>jQuery(document).ready(function(){FA_SportOdds_GetLeagues(<?php echo $pri_bid; ?>, '#<?php echo $this->get_field_id('league_primary'); ?>', <?php echo $pri_lid; ?>);});</script>
		<?php endif; ?>
		<?php if (! empty($pri_bid) && ! empty($sec_lid)): ?>
		<script>jQuery(document).ready(function(){FA_SportOdds_GetLeagues(<?php echo $sec_bid; ?>, '#<?php echo $this->get_field_id('league_secondary'); ?>', <?php echo $sec_lid; ?>);});</script>
		<?php endif; ?>
		<?php
	}
	
	private function parse_feed($xml) {
		$data = array();
		foreach ($xml->Event as $event) {
			$date = datetime::createfromformat('d/m/Y H:i:s', strval($event->attributes()->DateTimeGMT))->format('Y-m-d H:i:s');
			$data[strtotime($date)] = array(
							'home_team' => strval($event->Participants->Participant1->attributes()->Name),
							'away_team' => strval($event->Participants->Participant2->attributes()->Name),
							'odds' => array(
								'home' => array(
									'odds' => sprintf('%.2f', strval($event->MoneyLine->attributes()->Home)), 
									'line' => strval($event->MoneyLine->attributes()->Home_LineID)
								),
								'draw' => array(
									'odds' => sprintf('%.2f', strval($event->MoneyLine->attributes()->Draw)), 
									'line' => strval($event->MoneyLine->attributes()->Draw_LineID)
								),
								'away' => array(
									'odds' => sprintf('%.2f', strval($event->MoneyLine->attributes()->Away)), 
									'line' => strval($event->MoneyLine->attributes()->Away_LineID)
								)
							),
							'kickoff_GMT' => $date,
							'MEID' => strval($event->attributes()->MEID),
							'ID' => strval($event->attributes()->ID),
							'BranchID' => strval($event->attributes()->BranchID),
							'GroupID' => strval($event->MoneyLine->attributes()->Group_LineID),
							'LeagueName' => strval($event->attributes()->League)
						);
		}
		ksort($data);
		return $data;
	}
}
