var FA_SportOdds = {

	version: 1,
	selected: {},
	
	selectOdds: function(e) {
		var ele = jQuery(this);
		if (ele.hasClass('active')) {
			ele.removeClass('active');
			delete FA_SportOdds.selected[ele.parent().attr('data-meid')];
		}
		else {
			ele.parent().find('.active').removeClass('active');
			ele.addClass('active');
			FA_SportOdds.selected[ele.parent().attr('data-meid')] = { odds: parseFloat(ele.text().substring(1)), LineID: ele.attr('data-line'), GroupLineID: ele.attr('data-groupline'), MEID: ele.parent().attr('data-meid'), ID: ele.parent().attr('data-id') };
		}
		FA_SportOdds.calcProfit();
	},

	calcProfit: function() {
		if (jQuery.isEmptyObject(FA_SportOdds.selected) == true) {
			jQuery('#fa-sportodds-profit').empty();
			return;
		}
		var odds = 1.00;
		for (var meid in FA_SportOdds.selected) {
			odds *= FA_SportOdds.selected[meid].odds; 
		}
		jQuery('#fa-sportodds-profit').html((odds * parseFloat(jQuery('#fa-sportodds-stake').val())).toFixed(2));
	},
	
	betNow: function() {
		var url = this.testMobile() ? FA_SportOddsLinks.mobile : FA_SportOddsLinks.desktop;
		var oddsLinking = [];
		for (var i in FA_SportOdds.selected) {
			oddsLinking.push(FA_SportOdds.selected[i].MEID 
							+ ':' + FA_SportOdds.selected[i].ID 
							+ ':' + FA_SportOdds.selected[i].GroupLineID 
							+ ':' + FA_SportOdds.selected[i].LineID);
		}
		url += oddsLinking.join(',') + ',' + jQuery('#fa-sportodds-stake').val();
		window.open(url,'_blank').focus();
		return false;
		
	},

	calculateLocalTime: function(gmt)
	{
		var current_date = new Date();
		var d = new Date(gmt + "+0000");
		var oneDay = 24*60*60*1000;
		var diffDays = Math.round(Math.abs((d.getTime() - current_date.getTime())/(oneDay)));
		if(diffDays > 0){
			return dateFormat(d, "dd mmm");
		}
		else{
			return dateFormat(d, "HH:MM");
		}
	},
	
	testMobile: function() {
		return (/android|webos|iphone|ipad|ipod|blackberry|iemobile|opera mini/i.test(navigator.userAgent.toLowerCase()));
	}
};

jQuery(document).ready(function($) {
	$('.fa-sportodds-widget .odds div').on('click', FA_SportOdds.selectOdds);

	$(".fa-sportodds-widget .league-time").each(function(){
		var gmt = $(this).attr("data-gmt");
		var localTime = FA_SportOdds.calculateLocalTime(gmt);
		$(this).html(localTime);
	})
});
